c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine Adapt_Check_EastWest

      !integer status(MPI_STATUS_SIZE)   
      
      include 'common.2D'

      integer i_BC_Possible_global(n_procs_max),i_BC(n_procs_max)
      
      itime_check = 10e8   !0    !10e8     !
      
      !-- Adaptive algorithm --
      !i_East_Boundary_Change =  0  : No Change
      !i_East_Boundary_Change = -1  : Shift boundary -2h
      !i_East_Boundary_Change =  1  : Shift boundary +2h
      i_East_Boundary_Change_Possible = 0
      i_East_Boundary_Change = 0
      i_West_Boundary_Change = 0

        xmin_rank_old = xmin_rank
        xmax_rank_old = xmax_rank
        ncx_local_old = ncx_local
        nsheet_local_old = nsheet_local
c        !if(rank_id.lt.n_procs-1.and.(.NOT.iCartTop_periodicity(1)))then
c        if(rank_id.lt.n_procs-1)then    !CHECK THIS!!!!!!!!!!!!!!!!!!!!!
c          if(nFP_local_East.gt.nFP_local + nFP_difference_max)then
c            if(xmax_rank_East-xmin_rank_East.gt.xrank_length_max)then   !8.05*h)then
c              i_East_Boundary_Change =  1
c            end if
c          end if
c          if(nFP_local_East.lt.nFP_local - nFP_difference_max)then
c            if(xmax_rank-xmin_rank.gt.xrank_length_max)then   !8.05*h)then
c              i_East_Boundary_Change = -1
c            end if
c          end if
c        end if
        !-- Checking between procs not adjacent --
        if(rank_idx.lt.n_procs_x-1.and.rank_idx.gt.0)then
         if(nFP_local_East - nFP_local_West.gt.nFP_difference_max)then
           if(xmax_rank_East-xmin_rank_East.gt.xrank_length_max)then
             i_East_Boundary_Change_Possible =  1
           end if
         end if
         if(nFP_local_East - nFP_local_West.lt.-nFP_difference_max)then
           if(xmax_rank-xmin_rank.gt.xrank_length_max)then
             i_East_Boundary_Change_Possible = -1
           end if
         end if
        end if
        !-- Checking first & final processors --
        if(rank_idx.eq.0)then
         if(nFP_local_East - nFP_local.gt.nFP_difference_max)then
           if(xmax_rank_East-xmin_rank_East.gt.xrank_length_max)then
             i_East_Boundary_Change_Possible =  1
           end if
         end if
         if(nFP_local_East - nFP_local.lt.-nFP_difference_max)then
           if(xmax_rank-xmin_rank.gt.xrank_length_max)then   !8.05*h)then
             i_East_Boundary_Change_Possible = -1
           end if
         end if
        end if
        !-- JUST MESSING TO TRY AND DEBUG --
        !if(itime.eq.0)then
        !  if(rank_id.eq.1)i_East_Boundary_Change = -1
        !  if(rank_id.eq.2)i_East_Boundary_Change =  1
        !if(rank_id.eq.1)then
        !  i_East_Boundary_Change = -1
        !elseif(rank_id.eq.2)then
        !  i_East_Boundary_Change =  1
        !else
        !  i_East_Boundary_Change = 0
        !endif

        !-- For initial balancing --
        if(itime.eq.0)then

         !-- Don't reverse previous partition shift for 3 previous shifts --
         if( abs(nFP_local-nFP_local_previous1).gt.int(0.1*np/n_procs)
     &   .or.abs(nFP_local-nFP_local_previous2).gt.int(0.1*np/n_procs)
     &   .or.abs(nFP_local-nFP_local_previous3).gt.int(0.1*np/n_procs)
     &      )then
            i_East_Boundary_Change_Possible = 0
          endif

        endif

        !- Check Numbers of Particles either side of column -
        call MPI_GATHER(
     &        i_East_Boundary_Change_Possible , 1, MPI_INTEGER,
     &        i_BC_Possible_global(rank_id+1), 1, MPI_INTEGER,
     &        0, grid_comm, ierr)
c        if(rank_id.eq.0)then
c          print*,'i_BC_Possible_global ',
c     &            i_BC_Possible_global(1:n_procs)
c        endif
        do i_rank_x = 1,n_procs_x
          i_BC_column_stay = 0
          i_BC_column_moveLeft  = 0
          i_BC_column_moveRight = 0
          do i_rank_z = 1,n_procs_z

            i_rank = i_rank_x + (i_rank_z - 1)*n_procs_x

            !Check i_East_Boundary_Change_Possible
            if(i_BC_Possible_global(i_rank).gt.0)then
              i_BC_column_moveRight = i_BC_column_moveRight + 1
            elseif(i_BC_Possible_global(i_rank).lt.0)then
              i_BC_column_moveLeft = i_BC_column_moveLeft + 1
            else
              i_BC_column_stay = i_BC_column_stay + 1
            endif

          enddo
          !- Determine which way entire column should move -
          i_BC_column = 0
          if(i_rank_x.lt.n_procs_x)then
            if(i_BC_column_moveLeft.ge.i_BC_column_stay)then
              i_BC_column = -1
            endif
            if(i_BC_column_moveRight.ge.i_BC_column_moveLeft.and.
     &         i_BC_column_moveRight.ge.i_BC_column_stay)then
              i_BC_column = 1
            endif
          endif
          i_BC(i_rank_x) = i_BC_column
c          if(rank_id.eq.0)
c     &    print*,'i_rank_x, i_BC_column ',i_rank_x, i_BC_column,
c     &    i_BC_column_moveLeft,i_BC_column_stay,i_BC_column_moveRight
        enddo

        !- Transmit movements to column -
        call MPI_BCast(i_BC, n_procs_max, MPI_INTEGER,
     &                 0, grid_comm, ierr)
        i_East_Boundary_Change = i_BC(rank_idx+1)
c        print*,'rank_id, i_East_Boundary_Change, Possible ',
c     &          rank_id, i_East_Boundary_Change, 
c     &                   i_East_Boundary_Change_Possible
        !stop


        call MPI_SENDRECV(
     &    i_East_Boundary_Change  , 1, MPI_INTEGER, east, 1,
     &    i_West_Boundary_Change  , 1, MPI_INTEGER, west, 1,
     &    grid_comm, status, ierr)
        if(i_East_Boundary_Change.eq.1)then
          xmax_rank  = xmax_rank  + two_h
          xmax_local = xmax_local + two_h
          ncx_local  = ncx_local + 1
          nsheet_local = nsheet_local + ncz_local
          nct_local = nct_local + ncz_local
        end if
        if(i_East_Boundary_Change.eq.-1)then
          xmax_rank  = xmax_rank  - two_h
          xmax_local = xmax_local - two_h
          ncx_local  = ncx_local - 1
          nsheet_local = nsheet_local - ncz_local
          nct_local = nct_local - ncz_local
        end if
        if(i_West_Boundary_Change.eq.1)then
          xmin_rank  = xmin_rank  + two_h
          xmin_local = xmin_local + two_h
          ncx_local  = ncx_local - 1
          nsheet_local = nsheet_local - ncz_local
          nct_local = nct_local - ncz_local
        end if
        if(i_West_Boundary_Change.eq.-1)then
          xmin_rank  = xmin_rank  - two_h
          xmin_local = xmin_local - two_h
          ncx_local  = ncx_local + 1
          nsheet_local = nsheet_local + ncz_local
          nct_local = nct_local + ncz_local
        end if
c      end if

      if(nct_local .ge. nct_max) then
        print*
        print*,'ERROR in Adapt_MPI_Check_2D.f'
        print*,'No. of cells exceeds nct_max in common.2D'
        print*,'rank_id  ',rank_id
        print*,'nct_local ',nct_local
        print*,'nct_max   ',nct_max
        print*
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif 
      
c      if(itime.ge.itime_check
c     &   .and.itime/n_itime_Adapt*n_itime_Adapt.eq.itime)then
        do i=0,n_procs-1
          if(i.eq.rank_id.and.itime.gt.itime_check.and.
     &      (i_East_Boundary_Change.ne.0.or.
     &       i_West_Boundary_Change.ne.0)   )then
            print*
            print*,'Index_check - Adaptive Check, itime ', itime
            print*,'rank_id, east, west ',rank_id, east, west 
            print*,'i_East&West_Boundary_Change ',
     &              i_East_Boundary_Change, i_West_Boundary_Change
            print*,'nFP_local, nFP_local_East, nFP_local_West ',
     &              nFP_local, nFP_local_East, nFP_local_West
            !print*,'i_East_Boundary_Change ',i_East_Boundary_Change
            !print*,'i_West_Boundary_Change ',i_West_Boundary_Change
            !print*,'nFP_local      ',nFP_local
            !print*,'nFP_local_East ',nFP_local_East
            !print*,'two_h, 8.0*h ',two_h, 8.0*h
            print*,'xmin_rank_old, xmin_rank ',xmin_rank_old, xmin_rank
            print*,'xmax_rank_old, xmax_rank ',xmax_rank_old, xmax_rank
            print*,'ncx_local_old, ncx_local ',ncx_local_old, ncx_local
            print*,'nsheet_local_old, nsheet_local ',
     &              nsheet_local_old, nsheet_local
            print*
          end if
          !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
        end do
        !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
        !stop
c      end if
      
      
      end subroutine
