c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine Adapt_MPI_Regrid

      !integer status(MPI_STATUS_SIZE)   
      
      include 'common.2D'

      
      !-- Update domain lengths of neighbouring processes --
      nFP_local = np_local - nb_local*mod(iBC,2)
       call MPI_SENDRECV(
     &  nFP_local      , 1, MPI_INTEGER, west, 1,
     &  nFP_local_East , 1, MPI_INTEGER, east, 1,
     &  grid_comm, status, ierr)
       call MPI_SENDRECV(
     &  nFP_local      , 1, MPI_INTEGER, east, 1,
     &  nFP_local_West , 1, MPI_INTEGER, west, 1,
     &  grid_comm, status, ierr)
       call MPI_SENDRECV(
     &  xmax_rank        , 1, MPI_REAL, west, 1,
     &  xmax_rank_East   , 1, MPI_REAL, east, 1,
     &  grid_comm, status, ierr)
       xmin_rank_East = xmax_rank
      if(n_procs_z.gt.1)then
       call MPI_SENDRECV(
     &  nFP_local      , 1, MPI_INTEGER, below, 1,
     &  nFP_local_Above, 1, MPI_INTEGER, above, 1,
     &  grid_comm, status, ierr)
       call MPI_SENDRECV(
     &  nFP_local      , 1, MPI_INTEGER, above, 1,
     &  nFP_local_Below, 1, MPI_INTEGER, below, 1,
     &  grid_comm, status, ierr)
       call MPI_SENDRECV(
     &  zmax_rank      , 1, MPI_REAL, below, 1,
     &  zmax_rank_Above, 1, MPI_REAL, above, 1,
     &  grid_comm, status, ierr)
       zmin_rank_Above = zmax_rank
      endif

      !-- Regrid fixed particles if boundary interfaces have moved --
      if(i_East_Boundary_Change.ne.0.or.
     &   i_West_Boundary_Change.ne.0.or.
     &   i_Above_Boundary_Change.ne.0.or.
     &   i_Below_Boundary_Change.ne.0)then
c
c
        do i=1,nct_local
          mkind = 1
          nc(i,mkind) =0
          mkind = 2
          nc(i,mkind) =0
        enddo
        !-- Update ncall numbers to be used in the marching --
        ncall1  = -ncx_local+1               !South-East
        ncall2  =  ncx_local+1               !North-East
        ncall3  = -nsheet_local+1            !East       & Down
        ncall4  =  nsheet_local+1            !East       & Up
        ncall5  =  nsheet_local+ncx_local    !North      & Up
        ncall6  = -nsheet_local+ncx_local +1 !North-East & Down
        ncall7  =  ncall5+1                  !North-East & Up
        ncall8  =  nsheet_local-ncx_local    !South      & Up
        ncall9  = -nsheet_local-ncx_local+1  !South-East & Down
        ncall10 =  ncall8+1                  !South-East & Up
        
        ncall2_SE = -ncx_local+1       
        call ini_divide(1)
        i_resident_0 = 0  !Resident Fixed Particles
        call divide(1,nbf_local,1,i_resident_0)   !3rd argument = kind_p
        call keep_list
        i_dummy = 0   !All Boundary Particles
        
c        if(rank_id.eq.3)then
c          print*
c          print*,'In Adapt_MPI_Regrid'
c          print*,'rank_id , itime   ',rank_id, itime
c          print*,'nb_local, i_dummy ',nb_local,i_dummy
c          print*
c        endif
        
        if(iBC.eq.1.and.itime.gt.itime_init)then
          call updateNormals_2D(1,nb_local,i_dummy)
        endif
     
c        if(rank_id.eq.3)then
c          print*,'call updateNormals_2D called, rank_id = ',rank_id
c          print*,'nFP_difference_max, n_itime_Adapt ', 
c     &            nFP_difference_max, n_itime_Adapt
c          jjp = 2509
c          print*,'jjp, xnb, znb, xtb, ztb ',
c     &            jjp, xnb(jjp),znb(jjp),xtb(jjp),ztb(jjp)
c          !stop
c        endif  
        
c      !- Image Printout to Screen- 
c      itime_check = 0
c      if(itime.ge.itime_check.and.rank_id.eq.2)then
c      !if(itime.ge.itime_check.and.rank_id.eq.2)then
c        print*
c        print*,'rank_id ',rank_id
c        print*,'itime   ',itime
c        print*,'nbf_local      ',nbf_local
c        print*,'nbfm_local     ',nbfm_local
c        print*,'nbfreem_local  ',nbfreem_local
c        print*,'nb_local       ',nb_local
c        print*,'np_local       ',np_local
c        print*,'ipcount -> i, Type, xp, zp, xnb, znb'
c        do ipcount=1,nb_local
c          if(ipcount.le.nbf_local)then
c            i = ip_index_BP_local_1(ipcount)
c          else if(ipcount.le.nbfm_local)then
c            i = ip_index_BP_local_2(ipcount-nbf_local)
c          else if(ipcount.le.nbfreem_local)then
c            i = ip_index_BP_local_3(ipcount-nbfm_local)
c          else
c            i = ip_index_FP_local(ipcount-nb_local)
c          end if
c          write(*,454)ipcount,i,i_particleType(i),
c     &                xp(i),zp(i),xnb(i),znb(i)
c        end do
c      endif
c454   format(2i5,i2,4('  ',e12.6))
        
      end if
      
      end subroutine
