c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.
      
      subroutine SendRecv_Data_toBelow

      include 'common.2D'

      integer iabsolute_BP_going_Below(nGuestmax)
      integer iabsolute_BP_from_Above(nGuestmax)
      
      !-- Derived DataTypes --
      real(kind=kind_XZ )  P_xyz_data_going_Below(nGuestmax,2)
      real(kind=kind_XZ )  P_xyz_data_from_Above(nGuestmax,2)
      real P_data_going_Below(nGuestmax,15)
      real P_data_from_Above(nGuestmax,15)
      real BP_data_going_Below(nGuestmax,6)
      real BP_data_from_Above(nGuestmax,6)
      real Tau_data_going_Below(nGuestmax,3)
      real Tau_data_from_Above(nGuestmax,3)
c      integer BP_DataType, P_DataType, Tau_DataType, deltaptb_DType
c
      
      itime_check = 10e8   !0   !10e8
      irank_check = 1


      !SendRecv numbers of Guest Particles Between Host Processors

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then 
!         if(rank_id.eq.0.and.itime.ge.0)then   !if(rank_id.eq.-10)then
!           print*
!           print*,'In SendRecv_Data'
!           !print*,'Particles to be exported'
!         end if
!         do i=0,n_procs-1
!           if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
!             print*
!             print*,'rank_id ', rank_id
!             print*,'itime   ', itime
!             print*,'nb_local       ',nb_local
!             print*,'np_local       ',np_local
!             print*,'nbf_in_lz_2    ',nbf_in_lz_2
!             print*,'nbfreem_in_lz_2  ',nbfreem_in_lz_2
!             print*,'nb_in_lz_2     ',nb_in_lz_2
!             print*,'nFP_in_lz_2    ',nFP_in_lz_2
!             print*,'np_in_lz_2     ',np_in_lz_2
!             print*,'nbf_in_lz_ncz_localminus1 ',
!      &              nbf_in_lz_ncz_localminus1
!             print*,'nbfreem_in_lz_ncz_localminus1  ',
!      &              nbfreem_in_lz_ncz_localminus1
!             print*,'nb_in_lz_ncz_localminus1   ',
!      &              nb_in_lz_ncz_localminus1
!             print*,'nFP_in_lz_ncz_localminus1  ',
!      &              nFP_in_lz_ncz_localminus1
!             print*,'np_in_lz_ncz_localminus1   ',
!      &              np_in_lz_ncz_localminus1
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!         call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
!       endif

      !-- Zero non-communicating processes --
      if(rank_idz.eq.0
     &   .and.(.NOT.iCartTop_periodicity(3)))then
        nbf_from_Below = 0
        nbfm_from_Below = 0
        nbfreem_from_Below = 0
        np_from_Below = 0
        if(n_procs_z.eq.1)then
          nbf_from_Above = 0
          nbfm_from_Above = 0
          nbfreem_from_Above = 0
          np_from_Above = 0
        end if
      else if(rank_idz.eq.n_procs_z-1
     &   .and.(.NOT.iCartTop_periodicity(3)))then
        nbf_from_Above = 0
        nbfm_from_Above = 0
        nbfreem_from_Above = 0
        np_from_Above = 0
        if(n_procs_z.eq.1)then
          nbf_from_Below = 0
          nbfm_from_Below = 0
          nbfreem_from_Below = 0
          np_from_Below = 0
        end if
      end if

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.-10)then
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(i.eq.-rank_id)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, above, below ',rank_id, above, below 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
            
      !--- Up-Down Communications ---
        nbf_from_Below        = 0  
        nbfm_from_Below       = 0  
        nbfreem_from_Below    = 0  
        np_from_Below         = 0 
      !Send to Neighbour Below
        call MPI_SENDRECV(
     &    nbf_in_lz_2   , 1, MPI_INTEGER, below, 104,
     &    nbf_from_Above, 1, MPI_INTEGER, above, 104,
     &    grid_comm, status, ierr)
        call MPI_SENDRECV(
     &    nbfm_in_lz_2    , 1, MPI_INTEGER, below, 106,
     &    nbfm_from_Above , 1, MPI_INTEGER, above, 106,
     &    grid_comm, status, ierr)
        call MPI_SENDRECV(
     &    nbfreem_in_lz_2    , 1, MPI_INTEGER, below, 106,
     &    nbfreem_from_Above , 1, MPI_INTEGER, above, 106,
     &    grid_comm, status, ierr)
        call MPI_SENDRECV(
     &    np_in_lz_2     , 1, MPI_INTEGER, below, 107,
     &    np_from_Above  , 1, MPI_INTEGER, above, 107,
     &    grid_comm, status, ierr)
      
      !-- Temporary values after East->West transfer --
      nb_image_temp0      =  nb_image_local
      nFP_image_temp0     =  np_image_local - nb_image_local           
      nbf_image_temp0     =  nbf_image_local
      nbfm_image_temp0    =  nbfm_image_local - nbf_image_local
      nbfreem_image_temp0 =  nbfreem_image_local - nbfm_image_local

      !With no Open Boundary Water Particles (OBWPs)
      nb_from_Above = nbfreem_from_Above
      nb_from_Below = nbfreem_from_Below
          
      !-- Set Particle Numbers of Image on each Processor --    
      nbf_image_local  = nbf_image_local+ nbf_from_Above+ nbf_from_Below
      nbfm_image_local = nbfm_image_local
     &                      + nbfm_from_Above + nbfm_from_Below
      nbfreem_image_local= nbfreem_image_local
     &                      + nbfreem_from_Above + nbfreem_from_Below
      nb_image_local   = nb_image_local + nb_from_Above + nb_from_Below
      np_image_local   = np_image_local + np_from_Above + np_from_Below    
       
      nbp1_image_local = nb_image_local + 1
      
      !Error catching
      if(np_from_Above.gt.nGuestmax)then
        print*
        print*,'ERROR in SendRecv_Data.f'
        print*,'np_from_Above.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_Above ',np_from_Above
        print*,'nGuestmax    ',nGuestmax
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      else if(np_from_Below.gt.nGuestmax)then
        print*
        print*,'ERROR in SendRecv_Data.f'
        print*,'np_from_Below.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_Below ',np_from_Below
        print*,'nGuestmax    ',nGuestmax
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      end if
      if(np_image_local.gt.npar)then
        print*
        print*,'ERROR in SendRecv_Data.f'
        print*,'np_image_local.gt.npar'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_image_local ',np_image_local
        print*,'npar           ',npar
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif
      if(nbfreem_image_local.ne.nb_image_local)then
        print*
        print*,'ERROR in SendRecv_Data.f'
        print*,'nbfreem_image_local.ne.nb_image_local'
        print*,'rank_id, itime ',rank_id, itime
        print*,'nbfreem_image_local ',nbfreem_image_local
        print*,'nb_image_local    ',nb_image_local
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif
            
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !-- Printout Check for numbers of Particles being passed --
      if(1.eq.2)then
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &       'rank_id, nbf_in_lz_2, nbf_from_Above, nbf_from_Below '
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &        rank_id, nbf_in_lz_2, nbf_from_Above, nbf_from_Below
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &  'rank_id, nbfreem_in_lz_2,nbfreem_from_Above,nbfreem_from_Below'
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &   rank_id, nbfreem_in_lz_2,nbfreem_from_Above,nbfreem_from_Below
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &       'rank_id, nb_in_lz_2, nb_from_Above, nb_from_Below '
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &        rank_id, nb_in_lz_2, nb_from_Above, nb_from_Below
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &       'rank_id,  np_in_lz_2, np_from_Above, np_from_Below '
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &        rank_id, np_in_lz_2, np_from_Above, np_from_Below
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
      
          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-10)then
            print*,
     &       'rank_id,  nbf_image,  nbfreem_image,  nb_image, np_image '
          end if
          do i=0,n_procs-1     
            if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
              write(*,498),
     &        rank_id, nbf_image_local, nbfreem_image_local, 
     &                 nb_image_local  , np_image_local
            end if
            call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
          end do
      end if    !End of:  if(1.eq.2)then
498   format(5('  ',I5,'    '))     
      !--------------------------

      !Synchronize ip_index pointer array for resident particles
      nb_image_temp      = nb_image_temp0
      nFP_image_temp     = nFP_image_temp0
            
      nbf_image_temp     = nbf_image_temp0
      nbfm_image_temp    = nbfm_image_temp0
      nbfreem_image_temp = nbfreem_image_temp0
      
      
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---
      
      !-- Pack Particle data to be sent Below--
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!       if(itime.ge.itime_check.and.rank_id.eq.1)then
!         print*
!         print*,'Packing Particle Data to go Below'
!         print*,'rank_id, np_in_lz_2, nb_going_Below, np_going_Below ',
!      &          rank_id, np_in_lz_2, nb_going_Below, np_going_Below
!       end if
      nbfm_start    = nbf_in_lz_2 + 1
      nbfreem_start = nbfm_in_lz_2 + 1
      nFP_start     = nb_going_Below + 1
      do ii=1,np_going_Below     !do ii=1,np_in_lz_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_Below_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_Below_2(ii-nbf0_in_lz_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_Below_3(ii-(nbf0_in_lz_2+nbfm0_in_lz_2))
        !if(ii.le.nb_going_Below)then        
        !  i = iBP_going_Below(ii)
        else
          i = iFP_going_Below(ii-nb_going_Below)
        end if                
        P_xyz_data_going_Below(ii,1)  = xp(i)
c                                     = yp        
        P_xyz_data_going_Below(ii,2)  = zp(i)                
        P_data_going_Below(ii,1)  = up(i)
c                                 = vp        
        P_data_going_Below(ii,2)  = wp(i)        
        P_data_going_Below(ii,3)  = rhop(i)
        P_data_going_Below(ii,4)  = p(i)        
        P_data_going_Below(ii,5)  = pm(i)        
        P_data_going_Below(ii,6)  = pVol(i)        
        P_data_going_Below(ii,7)  = cs(i)                
        P_data_going_Below(ii,8)  = dudx_CSPH(i)
c                                 = dudy_CSPH(i)
        P_data_going_Below(ii,9)  = dudz_CSPH(i)
c                                 = dvdx_CSPH(i)
c                                 = dvdy_CSPH(i)
c                                 = dvdz_CSPH(i)
        P_data_going_Below(ii,10) = dwdx_CSPH(i)
c                                 = dwdy_CSPH(i)
        P_data_going_Below(ii,11) = dwdz_CSPH(i)
        P_data_going_Below(ii,12) = drhodx_CSPH(i)
c                                 = drhody_CSPH(i)
        P_data_going_Below(ii,13) = drhodz_CSPH(i)
        P_data_going_Below(ii,14) = dTEdx_CSPH(i)
c                                 = dTotalEdy_CSPH(i)
        P_data_going_Below(ii,15) = dTEdz_CSPH(i)
        Tau_data_going_Below(ii,1) = tau_xx_uno_rho2(i)
c                                  = tau_xy
        Tau_data_going_Below(ii,2) = tau_xz_uno_rho2(i)
c                                  = tau_yy
c                                  = tau_yz
        Tau_data_going_Below(ii,3) = tau_zz_uno_rho2(i)
        if(ii.le.nb_going_Below)then        
          BP_data_going_Below(ii,1) = xnb(i)
c                                   = ynb
          BP_data_going_Below(ii,2) = znb(i)
          BP_data_going_Below(ii,3) = xtb(i)
c                                   = ytb
          BP_data_going_Below(ii,4) = ztb(i)
c                                   = xsb
c                                   = ysb
c                                   = zsb
          BP_data_going_Below(ii,5)  = deltaptb(i,1)
          BP_data_going_Below(ii,6)  = deltaptb(i,2)
c                                    = deltapsb(i,1)
c                                    = deltapsb(i,2)
          iabsolute_BP_going_Below(ii) = iabsolute_BP_Pointer_index(i)          
        end if
c        !-- Debug Code------
c        if(rank_id.eq.1.and.itime.ge.itime_check)then
c          print*,'ii, i',ii, i
cc          print*,'xp(i), yp(i) ',
cc     &            xp(i), yp(i) 
c          print*,
c     &          'P_xyz_data_going_Below(ii, 1 & 2)  '
c          print*,P_xyz_data_going_Below(ii,1),
c     &           P_xyz_data_going_Below(ii,2)
c     
c          print*,
c     &          'P_data_going_Below(ii,1), P_data_going_Below(ii,2) '
c          print*,P_data_going_Below(ii,1), P_data_going_Below(ii,2),
c     &           P_data_going_Below(ii,3), P_data_going_Below(ii,4)
c          print*,P_data_going_Below(ii,5)
c          print*,P_data_going_Below(ii,6), P_data_going_Below(ii,7)
c          
c          if(i_particleType(i).le.2)then
c            print*,'iabsolute_BP_going_Below(ii) ',
c     &              iabsolute_BP_going_Below(ii)
c          end if
c        end if
      end do
     
      !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
            
c            
c      !- Send to Neighbour Below -
      call MPI_SENDRECV(
     & iabsolute_BP_going_Below, nb_going_Below, MPI_INTEGER,below, 131,
     & iabsolute_BP_from_Above , nb_from_Above , MPI_INTEGER,above, 131,
     & grid_comm, status, ierr)      
      !---Combined SendRecv's to Neighbour Below ---
      call MPI_SENDRECV(
     &  P_xyz_data_going_Below  , 1 , iP_xyzDataTypeA, below, 143,
     &  P_xyz_data_from_Above   , 1 , iP_xyzDataTypeA, above, 143,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  P_data_going_Below   , 1 , iP_DataTypeSR , below, 144,
     &  P_data_from_Above    , 1 , iP_DataTypeSR , above, 144,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  BP_data_going_Below, 1 , iBP_DataType  , below, 145,
     &  BP_data_from_Above , 1 , iBP_DataType  , above, 145,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  Tau_data_going_Below, 1 , iTau_DataType  , below, 146,
     &  Tau_data_from_Above , 1 , iTau_DataType  , above, 146,
     &  grid_comm, status, ierr)

c      call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      
c      !-- Debug Code------
c      if(itime.ge.itime_check)then
c        if(rank_id.eq.0)then
c          print*
c          print*,'In SendRecv_Data'
c          print*,'Particles numbers to be swapped'
c        end if
c        do i=0,n_procs-1
c          if(i.eq.-rank_id)then
c            write(*,*)
c            write(*,*),'rank_id ', rank_id
c            write(*,*),'nb_going_East ',nb_going_East
c            write(*,*),'np_going_East ',np_going_East
c            write(*,*),'nb_going_Below ',nb_going_Below
c            write(*,*),'np_going_Below ',np_going_Below
c            write(*,*),'nb_from_Above ',nb_from_Above
c            write(*,*),'np_from_Above ',np_from_Above
c            write(*,*),'nb_from_Below ',nb_from_Below
c            write(*,*),'np_from_Below ',np_from_Below
c          end if
c          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
c        end do
c      end if



496   format(i5,3('     ',i5,'  '),'  ',2('   ',e12.6))  

      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
                       
c      !-- Debug Code------
c      if(rank_id.eq.1.and.itime.ge.itime_check)then
c        print*
c        print*,'Unpacking Particle Data from East'
c        print*,'rank_id, itime, np_from_Above ',
c     &          rank_id,itime,np_from_Above
c        print*,'nbf_local       ',nbf_local
c        print*,'nbfm_local ',nbfm_local
c        print*,'nbfreem_local     ',nbfreem_local
c        print*,'nb_local        ',nb_local
c        print*,'nbf_from_Above       ',nbf_from_Above
c        print*,'nbfm_from_Above ',nbfm_from_Above
c        print*,'nbfreem_from_Above     ',nbfreem_from_Above
c        print*,'nb_from_Above        ',nb_from_Above
c        print*,'nbf_image_local       ',nbf_image_local
c        print*,'nbfm_image_local ',nbfm_image_local
c        print*,'nbfreem_image_local     ',nbfreem_image_local
c        print*,'nb_image_local        ',nb_image_local
c        print*,'nbf_image_temp       ',nbf_image_temp
c        print*,'nbfm_image_temp ',nbfm_image_temp
c        print*,'nbfreem_image_temp     ',nbfreem_image_temp
c        print*,'nb_image_temp        ',nb_image_temp
c        print*,'np_local ',np_local
c        print*,'kk_highest ',kk_highest
c        print*,'ii, i_image, nb/FP_image_temp, ip_index_#P_local,
c     &xp(i_image), zp(i_image)'
c      end if
      !-- Unpack Particle data --
      do ii=1,np_from_Above
        !i_image = np_local + np_from_Below + ii    !CORRECT THIS FOR DISORDERED PARTICLES!!!!
        !i_image = kk_highest + np_from_Below + ii
        i_image = kk_highest_after_SR_toWest + ii
        xp(i_image)             = P_xyz_data_from_Above(ii,1)
c       yp
        zp(i_image)             = P_xyz_data_from_Above(ii,2)
        up(i_image)             = P_data_from_Above(ii,1)
c       vp
        wp(i_image)             = P_data_from_Above(ii,2)
        rhop(i_image)           = P_data_from_Above(ii,3)
        p(i_image)              = P_data_from_Above(ii,4)
        pm(i_image)             = P_data_from_Above(ii,5)
        pVol(i_image)           = P_data_from_Above(ii,6)
        cs(i_image)             = P_data_from_Above(ii,7)
        dudx_CSPH(i_image)      = P_data_from_Above(ii,8)
c       dudy_CSPH(i_image)        
        dudz_CSPH(i_image)      = P_data_from_Above(ii,9)
c       dvdx_CSPH(i_image)        
c       dvdy_CSPH(i_image)        
c       dvdz_CSPH(i_image)        
        dwdx_CSPH(i_image)      = P_data_from_Above(ii,10)
c       dwdy_CSPH(i_image)        
        dwdz_CSPH(i_image)      = P_data_from_Above(ii,11)
        drhodx_CSPH(i_image)    = P_data_from_Above(ii,12)
c       drhody_CSPH(i_image)        
        drhodz_CSPH(i_image)    = P_data_from_Above(ii,13)
        dTEdx_CSPH(i_image)     = P_data_from_Above(ii,14)
c       dTEdy_CSPH(i_image)        
        dTEdz_CSPH(i_image)     = P_data_from_Above(ii,15)
        tau_xx_uno_rho2(i_image) = Tau_data_from_Above(ii,1)
c       tau_xy                   = Tau
        tau_xz_uno_rho2(i_image) = Tau_data_from_Above(ii,2)
c       tau_yy                   = Tau
c       tau_yz                   = Tau
        tau_zz_uno_rho2(i_image) = Tau_data_from_Above(ii,3)
        iflag(i_image) = 1
        !-- Append to ip_index pointer arrays --
        if(ii.le.nb_from_Above)then
          if(i_image.gt.nb_max)then
            print*
            print*,'ERROR in SendRecv_Data_2D.f'
            print*,'i_image.gt.nb_max '
            print*,'Adjust nb_max in common.2D'
            print*,'rank_id, itime ',rank_id, itime
            print*,'i_image   ',i_image
            print*,'nb_max    ',nb_max
            print*
            stop
          endif
          nb_image_temp = nb_image_temp + 1
          ip_index_BP_local(nb_image_temp) = i_image
          !Normals
          xnb(i_image)        = BP_data_from_Above(ii,1)
c         ynb
          znb(i_image)        = BP_data_from_Above(ii,2)
          xtb(i_image)        = BP_data_from_Above(ii,3)
c         ytb
          ztb(i_image)        = BP_data_from_Above(ii,4)
c         xsb
c         ysb
c         zsb
          deltaptb(i_image,1) = BP_data_from_Above(ii,5)
          deltaptb(i_image,2) = BP_data_from_Above(ii,6)
c         deltapsb(i_image,1)
c         deltapsb(i_image,2)
         iabsolute_BP_Pointer_index(i_image)=iabsolute_BP_from_Above(ii)
c          !- Array & Pointer printout -
c          if(rank_id.eq.0.and.itime.ge.itime_check)then
c            write(*,496),ii, i_image, nb_image_temp,  
c     &       ip_index_BP_local(nb_image_temp),xp(i_image), zp(i_image)
c            print*,'P_data_from_Above'
c            write(*,*)P_xyz_data_from_Above(ii,1),
c     &                P_xyz_data_from_Above(ii,2)
c            
c            write(*,*)P_data_from_Above(ii,1), P_data_from_Above(ii,2)
c            write(*,*)P_data_from_Above(ii,3), P_data_from_Above(ii,4)
c            write(*,*)P_data_from_Above(ii,5), P_data_from_Above(ii,6)
c            write(*,*)P_data_from_Above(ii,7)
c            write(*,*)'iabsolute_BP_Pointer_index(i_image) ',
c     &                 iabsolute_BP_Pointer_index(i_image)
c          end if
          !- Indexing -
          nb_image_temp2 = nb_image_temp - nb_image_temp0   !nb_image_temp2 = nb_image_temp - nb_local
          if(nb_image_temp2.le.nbf_from_Above)then
            i_particleType(i_image) = 1   !Fixed Boundary Particle
            nbf_image_temp = nbf_image_temp + 1
            ip_index_BP_local_1(nbf_image_temp) = i_image
          else if(nb_image_temp2.le.nbfm_from_Above)then
            i_particleType(i_image) = 2   !Forced Moving Boundary Particle
            nbfm_image_temp = nbfm_image_temp + 1
            ip_index_BP_local_2(nbfm_image_temp) = i_image
          else if(nb_image_temp2.le.nbfreem_from_Above)then
            i_particleType(i_image) = 3   !Free Moving Boundary Particle
            nbfreem_image_temp = nbfreem_image_temp + 1
            ip_index_BP_local_3(nbfreem_image_temp) = i_image
          end if
        else
          nFP_image_temp = nFP_image_temp + 1
          ip_index_FP_local(nFP_image_temp) = i_image
c          !- Array & Pointer printout -
c          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-12)then
c            write(*,496),ii, i_image, nFP_image_temp,  
c     &       ip_index_FP_local(nFP_image_temp),xp(i_image), zp(i_image)
c            print*,'P_data_from_Above'
c            write(*,*)P_xyz_data_from_Above(ii,1),
c     &                P_xyz_data_from_Above(ii,2)
c            
c            write(*,*)P_data_from_Above(ii,1), P_data_from_Above(ii,2)
c            write(*,*)P_data_from_Above(ii,3), P_data_from_Above(ii,4)
c            write(*,*)P_data_from_Above(ii,5), P_data_from_Above(ii,6)
c            write(*,*)P_data_from_Above(ii,7)
c          end if
          i_particleType(i_image) = 4   !Fluid Particle
        end if
c        !-- Debug Code------
c        if(rank_id.eq.0.and.itime.ge.itime_check)then
c          print*,'i_particleType(i_image) ',i_particleType(i_image)
c          print*
c        endif
      end do
      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
!       !-- Printout Check for Image
!       if(itime.ge.itime_check.and.rank_id.eq.irank_check)then
!       !if(itime.ge.0.and.rank_id.eq.2)then
!         print*
!         print*,'rank_id         ',rank_id
!         print*,'itime           ',itime
!         print*,'nbf_local       ',nbf_local
!         print*,'nbfm_local ',nbfm_local
!         print*,'nbfreem_local     ',nbfreem_local
!         print*,'nb_local        ',nb_local
!         print*,'np_local        ',np_local
!         print*,'nbf_from_Below ',nbf_from_Below
!         print*,'nbf_from_Above ',nbf_from_Above
!         print*,'nbfm_from_Below  ',nbfm_from_Below
!         print*,'nbfm_from_Above  ',nbfm_from_Above
!         print*,'nbfreem_from_Below  ',nbfreem_from_Below
!         print*,'nbfreem_from_Above  ',nbfreem_from_Above
!         print*,'nb_from_Below    ',nb_from_Below
!         print*,'nb_from_Above    ',nb_from_Above
!         print*,'np_from_Below    ',np_from_Below
!         print*,'np_from_Above    ',np_from_Above
!         print*,'nbf_image_local ',nbf_image_local
!         print*,'nbfm_image_local  ',nbfm_image_local
!         print*,'nbfreem_image_local      ',nb_image_local
!         print*,'nb_image_local   ',nb_image_local
!         print*,'np_image_local   ',np_image_local
!         print*,'nb_image_temp    ',nb_image_temp
!         print*,'nFP_image_temp   ',nFP_image_temp
!         if(1.eq.1)then
!           !do ipcount=1,np_image_local
!           do ipcount=np_local + 1,np_image_local
!             if(ipcount.le.nbf_image_local)then
!               i = ip_index_BP_local_1(ipcount)
!             else if(ipcount.le.nbfm_image_local)then
!               i = ip_index_BP_local_2(ipcount-nbf_image_local)
!             else if(ipcount.le.nbfreem_image_local)then
!               i = ip_index_BP_local_3(ipcount-nbfm_image_local)
!             else
!               i = ip_index_FP_local(ipcount-nb_image_local)
!             end if
!             write(*,494),'ipcount -> i, xp, zp ',
!      &                  ipcount,i,xp(i),zp(i)
!           end do
!         end if
!         !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
!       end if
494   format(1(a21,'  '),2(i6,'  '),2(f16.10,' '))
495   format(2(i6,'  '),8(f10.6,' '))

c      call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      
c      !-- Debug Code------
c      if(1.eq.2.and.rank_id.eq.1.and.itime.ge.itime_check)then
c        print*
c        print*,'Image Normals, end of SendRecv_Data, rank_id ',rank_id
c        print*,
c     &' i    xp     zp     xnb     znb   deltaptb(i,1)   deltaptb(i,2)'
c        do ipcount = 1, nb_image_local 
c          i = ip_index_BP_local(ipcount)
c          write(*,495),ipcount,i,xp(i),zp(i),xnb(i),znb(i),
c     &               xtb(i),ztb(i),deltaptb(i,1),deltaptb(i,2)
c        end do
c        print*
c      end if
      
      !stop
      
      end subroutine
