c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine SendRecv_KGC_Matrices_toBelow
c
      include 'common.2D'
              
      real A_KGC_going_Below(nGuestmax,4) 
      real A_KGC_from_Above(nGuestmax,4)

      itime_check = 10e8   !0   !10e8   !0   !
      
!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*
!           print*,'In update_kernelSummations'
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(itime.ge.itime_check.and.i.eq.rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, above, below ',rank_id, above, below 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
      
      !-- Zero non-communicating processes --
      if(rank_idz.eq.0
     &   .and.(.NOT.iCartTop_periodicity(3)))then
        nb_going_Below = 0
        np_going_Below = 0
        if(n_procs_z.eq.1)then
          nb_going_Above = 0
          np_going_Above = 0
        end if
      else if(rank_idz.eq.n_procs_z-1
     &   .and.(.NOT.iCartTop_periodicity(3)))then
        nb_going_Above = 0
        np_going_Above = 0
        if(n_procs_z.eq.1)then
          nb_going_Below = 0
          np_going_Below = 0
        end if
      end if

                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---


        !-- Pack Particle data to be sent back Below--
!         if(itime.ge.itime_check.and.rank_id.eq.0)then
!           print*
!           print*,'Particles being sent back Below'
!           print*,'rank_id ',rank_id
!           print*,'np_from_Below ',np_from_Below
! c          print*,
! c     &    'ii, i_image, xp_going_back_Below(ii), zp_going_back_Below(ii)'
!           print*,
!      &    'ii,  i_image, xp,   zp,   A_KGC_going_Below(ii,1)'
!         end if
      nbfm_start    = nbf_in_lz_2 + 1
      nbfreem_start = nbfm_in_lz_2 + 1
      nFP_start     = nb_going_Below + 1
      do ii=1,np_going_Below     !do ii=1,np_in_lz_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_Below_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_Below_2(ii-nbf0_in_lz_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_Below_3(ii-(nbf0_in_lz_2+nbfm0_in_lz_2))
        !if(ii.le.nb_going_Below)then        
        !  i = iBP_going_Below(ii)
          else
            i = iFP_going_Below(ii-nb_going_Below)
          end if                
          A_KGC_going_Below(ii,1) = aL_a11(i)            
          A_KGC_going_Below(ii,2) = aL_a12(i)            
          A_KGC_going_Below(ii,3) = aL_a21(i)            
          A_KGC_going_Below(ii,4) = aL_a22(i)            
!          !- Diagnostic Info -
c          if(itime.ge.itime_check.and.rank_id.eq.0)then
c            print*,
c     &      ii,i_image,xp(i),zp(i),
c     &      A_KGC_going_Below(ii,1)
c          end if         
        end do  
      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !--- SendRecv kernel summation information back to original processors ---
      !Send data back Below
       call MPI_SENDRECV(
     &     A_KGC_going_Below, 1  , iKGC_DataType2, below, 1,
     &     A_KGC_from_Above , 1  , iKGC_DataType2, above, 1,
     &     grid_comm, status, ierr)
      
c      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      
      !-- Unpack Data & Update summations on original processors
      

      !-- UnPack Particle data from Above --
!       if(itime.ge.itime_check.and.rank_id.eq.4)then
!         print*,'Unpacking data originally sent Above'
!         print*,'np_from_Above ',np_from_Above
!         print*,'Summing sum_wab'
!         print*,'ii, i, sum_wab(i), A_KGC_from_Above(ii,1)'
!       end if
      do ii=1,np_from_Above
        i_image = kk_highest_after_SR_toWest + ii   !For kk_highest, see index_check.f
        aL_a11(i_image) = A_KGC_from_Above(ii,1)
        aL_a12(i_image) = A_KGC_from_Above(ii,2)
        aL_a21(i_image) = A_KGC_from_Above(ii,3)
        aL_a22(i_image) = A_KGC_from_Above(ii,4)
!        !- Diagnostic Info -
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          write(*,494),ii, i, sum_wab(i), A_KGC_from_Above(ii,1)
c        end if        
      end do


494   format(2(i5,'    '),4(f12.6,'    '))      
495   format(2(i5,'    '),4(e12.6,'    '))      
      
        
      end subroutine
