c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine SendRecv_updatedKernelSummations_toBelow

      include 'common.2D'


      !-- Derived DataTypes --
      real sumW_data_going_Below(nGuestmax,4)
      real sumW_data_from_Above(nGuestmax,4)
c      integer sumW_DataType

c
      itime_check = 10e8   !0   !10e8


      !SendRecv numbers of Guest Particles Between Host Processors

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.-10)then
!           print*
!           print*,'In SendRecv_updatedKernelSummation'
!           !print*,'Particles to be exported'
!         end if
! 
!         if(rank_id.eq.-10)then
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, above, below ',rank_id, above, below 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
! 
!         if(rank_id.eq.-10)then
!           print*,'In SendRecv_updatedKernelSummations'
!           print*
!           print*,'rank_id        ',rank_id
!           print*,'nb_local       ',nb_local
!           print*,'np_local       ',np_local
!           print*,'nb_from_Above   ',nb_from_Above
!           print*,'np_from_Above   ',np_from_Above
!           print*,'nb_from_Below   ',nb_from_Below
!           print*,'np_from_Below   ',np_from_Below
!           print*,'nb_image_local ',nb_image_local
!           print*,'np_image_local ',np_image_local        
!           print*,'nb_going_Above   ',nb_going_Above
!           print*,'np_going_Above   ',np_going_Above
!           print*,'nb_going_Below   ',nb_going_Below
!           print*,'np_going_Below   ',np_going_Below
!           print*,'above, below      ',above, below 
!         end if

      !-- Error Catching --
      if(np_going_Above.gt.nGuestmax)then
        print*
        print*,'In SendRecv_updatedKernelSummations.f '
        print*,'np_going_Above.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_going_Above ',np_going_Above
        stop
      end if
      if(np_going_Below.gt.nGuestmax)then
        print*
        print*,'In SendRecv_updatedKernelSummations.f '
        print*,'np_going_Above.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_going_Above ',np_going_Above
        stop
      end if
      
      
      
      !-- Pack Particle data to be sent Below--
      !if(rank_id.eq.1)then
      !  print*
      !  print*,'Packing Particle Data to go Below'
      !  print*,'rank_id, np_in_lz_2 ',
c     &!          rank_id, np_in_lz_2
      !end if
      nb_going_Below = nb_in_lz_2
      np_going_Below = np_in_lz_2
      nbfm_start    = nbf_in_lz_2 + 1
      nbfreem_start = nbfm_in_lz_2 + 1
      nFP_start     = nb_going_Below + 1
      do ii=1,np_going_Below     !do ii=1,np_in_lz_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_Below_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_Below_2(ii-nbf0_in_lz_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_Below_3(ii-(nbf0_in_lz_2+nbfm0_in_lz_2))
        !if(ii.le.nb_going_Below)then        
        !  i = iBP_going_Below(ii)
        else
          i = iFP_going_Below(ii-nb_going_Below)
        end if        
        sumW_data_going_Below(ii,1)   = sum_wab(i)
        sumW_data_going_Below(ii,2)   = rhop_sum(i)                
        sumW_data_going_Below(ii,3)   = sum_dWdx(i)        
        sumW_data_going_Below(ii,4)   = sum_dWdz(i)

c        if(rank_id.eq.1)then
c          print*,'ii, i',ii, i
c          print*,'xp(i), yp(i) ',
c     &            xp(i), yp(i) 
c          print*,'xp_going_Below(ii), yp_going_Below(ii) ',
c     &            xp_going_Below(ii), yp_going_Below(ii) 
c        end if
      end do
     
      !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      
      
      !Send to Below Neighbour
      !---Combined SendRecv's to Below Neighbour ---
      call MPI_SENDRECV(
     &  sumW_data_going_Below   , 1 , isumW_DataType, below, 143,
     &  sumW_data_from_Above    , 1 , isumW_DataType, above, 143,
     &  grid_comm, status, ierr)
      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      

496   format(i3,3('     ',i5,'  '),'  ',2('   ',e12.6))  
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
                       
c      if(rank_id.eq.0)then
c        print*
c        print*,'Unpacking Particle Data from Above'
c        print*,'rank_id, np_from_Above ',rank_id,np_from_Above
c        print*,'ii, i_image, nb/p_image_temp, ip_index_#P_local,
c     &!xp(i_image), yp(i_image)'
c      end if
      !-- Unpack Particle data --
      do ii=1,np_from_Above
        !i_image = np_local + np_from_Below + ii    !CORRECT THIS FOR DISORDERED PARTICLES!!!!
        !i_image = kk_highest + np_from_Below + ii
        i_image = kk_highest + ii
        sum_wab(i_image)    = sumW_data_from_Above(ii,1)
        rhop_sum(i_image)   = sumW_data_from_Above(ii,2)
        sum_dWdx(i_image)   = sumW_data_from_Above(ii,3)
        sum_dWdz(i_image)   = sumW_data_from_Above(ii,4)
c
      end do
      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      
      !if(itime.ge.itime_check.and.rank_id.eq.2)then
      !  print*
      !  i = 1111
      !  print*,'rank_id ',rank_id
      !  print*,'i, xp(i), yp(i), sum_wab(i)'
      !  print*,i, xp(i), yp(i), sum_wab(i)
      !end if
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point

      !if(rank_id.eq.0)then
      !  print*
      !  print*,'Finished SendRecv_updatedKernelSummations'
      !  print*
      !end if
      !stop
      
      
      end subroutine
