c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine ac		!ac_KGC_2D.f
c
      include 'common.2D'

      itime_check = 10e8     !0    !10e8   !0    !
      i_rank_check = 1
      i_ParticleCheck = 619
c
c  ...  store useful arrays
c
      icall=0     !Calculate normalising kernels
      i_Shepard_typeMin = 3

      !- MPI Version -
      if(num_FB.gt.0)then
        if(iBC.eq.1)then
          nstart_ac = nbfm_local+1
        else
          nstart_ac = nstart  !=1
        endif
      else
        nstart_ac = nstart
      endif
      do ipcount=nstart_ac,np_image_local
         if(ipcount.le.nbf_image_local)then
           i = ip_index_BP_local_1(ipcount)
         else if(ipcount.le.nbfm_image_local)then
           i = ip_index_BP_local_2(ipcount-nbf_image_local)
         else if(ipcount.le.nbfreem_image_local)then
           i = ip_index_BP_local_3(ipcount-nbfm_image_local)
         else
           i = ip_index_FP_local(ipcount-nb_image_local)
         end if

      enddo
      do i=1,npar
c        -- Kernel ReNormalisation ARRAYS --
     
         aM_a11(i)=0.    !Mi(1,1)
         aM_a12(i)=0.    !Mi(1,2)
         aM_a21(i)=0.    !Mi(2,1)
         aM_a22(i)=0.    !Mi(2,2)
         aL_a11(i)=0.    !Li(1,1)
         aL_a12(i)=0.    !Li(1,2)
         aL_a21(i)=0.    !Li(2,1)
         aL_a22(i)=0.    !Li(2,2)

      enddo
      
      !- MPI Version -
      if(iBC.eq.1)then
        do ipcount=1,nb_image_local
           i = ip_index_BP_local(ipcount)
c          -- Kernel ReNormalisation ARRAYS --
     
           aM_a11(i)=0.    !Mi(1,1)
           aM_a12(i)=0.    !Mi(1,2)
           aM_a21(i)=0.    !Mi(2,1)
           aM_a22(i)=0.    !Mi(2,2)
           aL_a11(i)=0.    !Li(1,1)
           aL_a12(i)=0.    !Li(1,2)
           aL_a21(i)=0.    !Li(2,1)
           aL_a22(i)=0.    !Li(2,2)
        enddo
      endif

      !-- X-Direction MPI Topology Periodicity --
      if(iCartTop_periodicity(1).or.
     &   (rank_idx.gt.0.and.rank_idx.lt.n_procs_x-1))then
        ncx_start = 2
        ncx_finish = ncx_local - 1
      else if(rank_idx.eq.0)then
        ncx_start = 1
        ncx_finish = ncx_local - 1
      else if(rank_idx.eq.n_procs_x-1)then
        ncx_start = 2
        ncx_finish = ncx_local
      else !Just incase-error catching
        ncx_start = 2
        ncx_finish = ncx_local
        print*
        print*,'ac.f'
        print*,'itime ',itime
        print*,'rank_id ',rank_id
        print*,'rank_idx, rank_idz ',
     &          rank_idx, rank_idz
        print*,'ncx_start = ',ncx_start
        print*,'ncx_finish= ',ncx_finish
        stop
      end if
      !-- Z-Direction MPI Topology Periodicity --
      if(iCartTop_periodicity(3).or.
     &   (rank_idz.gt.0.and.rank_idz.lt.n_procs_z-1))then
        ncz_start = 2
        ncz_finish = ncz_local - 1
      else if(rank_idz.eq.0)then
        ncz_start = 1
        ncz_finish = ncz_local - 1
      else if(rank_idz.eq.n_procs_z-1)then
        ncz_start = 2
        ncz_finish = ncz_local
      else if(ndim.eq.2.and.n_procs_x.eq.1)then
        if(rank_idz.eq.0)then
          ncz_start = 1
          ncz_finish = ncz_local - 1
        elseif(rank_idz.lt.n_procs_z-1)then
          ncz_start = 2
          ncz_finish = ncz_local-1
        else
          ncz_start = 2
          ncz_finish = ncz_local
        endif
      else !Just incase-error catching
        ncz_start = 2
        ncz_finish = ncz_local
        print*
        print*,'ac.f'
        print*,'itime ',itime
        print*,'rank_id ',rank_id
        print*,'rank_idx, rank_idz ',
     &          rank_idx, rank_idz
        print*,'ncz_start = ',ncz_start
        print*,'ncz_finish= ',ncz_finish
        stop
      end if
c     ncy_start = 1
c     ncy_finish = ncy_local
c     ncz_start = 1
c     ncz_finish = ncz_local
      lz2_min = ncz_start + 1  !2

c      !- Diagnostic Info -
c      if(itime.ge.itime_check.and.rank_id.eq.1)then
c        print*
c        print*,'In AC.f before pre_celij calls'
c        i =  i_ParticleCheck
c        print*,'i, xp, zp ',i,xp(i),zp(i)
c        print*,'up, wp ',up(i),wp(i)
c        print*,'ax, az ',ax(i),az(i)
c        print*,'ar     ',ar(i)
c        print*,'rhop(i) ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        print*
c      end if
       
       ly2 = 0   !Default Y-Periodic value
       do kind_p1=1,2
       ini_kind_p2=mod(kind_p1,2)+1  !Gives the alternative value to kind_p2 of kind_p1
              
       do lz=ncz_start,ncz_finish
       do lx=ncx_start,ncx_finish
       
       
         j1 = lx + (lz-1)*ncx_local

         if(nc(j1,kind_p1).gt.0) then
c                            ! if the cell is not empty, then
c                            ! loop over it and over neighboring
c                            ! cells

c         print*,'kind_p1, lx, lz, j1 ',kind_p1,lx, lz, j1

c         !-- Cells in the same XY sheet --
          lx2 = lx+1
          lz2 = lz+1
          

          !- Special correction for MPI Cartesian Topology -
          lx2t = lx2
          lz2t = lz2

          if(iCartTop_periodicity(1))then
            lx2t = lx2t+1   !Add one to activate periodicity correction 
          endif
c         if(iCartTop_periodicity(2))then
c           ly2t = ly2t+1   !Add one to activate periodicity correction 
c         endif
          if(iCartTop_periodicity(3))then
            lz2t = lz2t+1   !Add one to activate periodicity correction
          endif
          !------------------------------------------------
          
          !- EAST -
          if(lx2.le.ncx_local)then
            call pre_celij(j1,j1+1,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,1)     !East
          end if

          !- NORTH -
          if(lz2.le.ncz_local)then
            call pre_celij(j1,j1+ncx_local,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,3)     !North
          !- NORTH-EAST -  
            if(lx2.le.ncx_local)then 
            call pre_celij(j1,j1+ncall2,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,5)     !North-East
            endif
          endif

          !- SOUTH-EAST -
          if(lx2.le.ncx_local.and.lz2.gt.lz2_min)then
            call pre_celij(j1,j1+ncall1,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,9)     !South-East
          endif

          !-- PERIODIC CALLS ---
               
          !-- Cells in the same XZ sheet --
          !- X-Dir Periodic -
          if(i_periodicOBs(1).eq.1.and.lx.eq.ncx_local)then
            call pre_celij(j1,j1+1-ncx_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,2)                        !East        Periodic X-Dir only
            if(lz2.le.ncz_local)then
              call pre_celij(j1,j1+ncall2-ncx_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,6)                        !North-East  Periodic X-Dir only
            endif
            if(lz2.gt.2)then
              call pre_celij(j1,j1+ncall1-ncx_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,10)                       !South-East  Periodic X-Dir only
            endif
            if(i_periodicOBs(3).eq.1)then
              if(lz.eq.ncz_local)then
                call pre_celij(j1,j1+ncall2-ncx_local-nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,7)                        !North-East  Periodic X-Dir & Z-Dir
              else if(lz.eq.1)then
                call pre_celij(j1,j1+ncall1-ncx_local+nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,11)                       !South-East  Periodic X-Dir & Z-Dir
              endif
            endif
          endif
          !- Z-Dir Periodic Only -
          if(i_periodicOBs(3).eq.1)then 
            if(lz.eq.ncz_local)then
              call pre_celij(j1,j1+ncx_local-nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,4)                        !North       Periodic Z-Dir only
              if(lx2.le.ncx_local)then
                call pre_celij(j1,j1+ncall2-nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,8)                        !North-East  Periodic Z-Dir only
              end if
            endif
            if(lz2.eq.2.and.lx2.le.ncx_local)then
              call pre_celij(j1,j1+ncall1+nsheet_local,
     &                kind_p1,ini_kind_p2,lx2,lz2,12)                       !South-East  Periodic Z-Dir only
            end if
          end if

        endif  !End of: if(nc(j1,kind_p1).gt.0)then

      enddo
      enddo

       
      !- Extra SOUTH-EAST for Z-dir Cartesian MPI Topology -
      if(n_procs_z.gt.1.and.rank_idz.lt.n_procs_z-1)then
        lz=ncz_finish + 1
        do lx=ncx_start,ncx_finish      
          j1 = lx + (lz-1)*ncx_local
          if(nc(j1,kind_p1).gt.0) then
c           !-- Cells in the same XY sheet --
            lx2 = lx+1
            lz2 = lz+1

            !- Special correction for MPI Cartesian Topology -
            lx2t = lx2
            lz2t = lz2
       
            if(iCartTop_periodicity(1))then
              lx2t = lx2t+1   !Add one to activate periodicity correction 
            endif
c           if(iCartTop_periodicity(2))then
c             ly2t = ly2t+1   !Add one to activate periodicity correction 
c           endif
            if(iCartTop_periodicity(3))then
              lz2t = lz2t+1   !Add one to activate periodicity correction
            endif
            if(lx2.le.ncx_local)then
              call pre_celij(j1,j1+ncall1,
     &                 kind_p1,ini_kind_p2,lx2t,lz2t,13)     !South-East
            endif
          endif
        enddo
      endif


       do j1x = ncx_start, ncx_finish
       do j1z = ncz_start, ncz_finish
       
         j1 = j1x + (j1z-1)*ncx_local
           if(nc(j1,kind_p1).gt.0)
     +        call pre_self(j1,kind_p1,ini_kind_p2)
       enddo
       enddo
       
       
       enddo   !End of:  do kind_p1=1,2
       

      !SendRecv all acceleration summations back to origin processors
      !if(i_call_NorthSouth.eq.1) call update_KGC_Summations_fromSouth
      if(i_call_UpDown    .eq.1) call update_KGC_Summations_fromBelow
      call update_KGC_Summations_fromWest

      !-- Invert gradient correction Matrix --

      do ipcount=nstart_ac,np_local
         call ipcount_to_i(ipcount,i)
         if(i_particleType(i).eq.4)then   !if (i.gt.nb.and.iflag(i).gt.0) then !Only for Fluid particles
                                                !inside the limits
             aM_a12(i)=0.5*(aM_a12(i)+aM_a21(i)) ! M should be symmetric
             aM_a21(i)=aM_a12(i)                                 
             detM=aM_a11(i)*aM_a22(i)-aM_a12(i)*aM_a21(i)  !Determinant of matrix M det(M)

             if(abs(detM).gt.0.01.and.abs(aM_a11(i)).gt.0.25
     +         .and.abs(aM_a22(i)).gt.0.25) then  !Only for "well conditioned" matrices  
               one_over_detM = 1.0/detM
               aL_a11(i) =  aM_a22(i)*one_over_detM  !Li(1,1)=Mi(1,1)/det(M)
               aL_a22(i) =  aM_a11(i)*one_over_detM  !Li(2,2)=Mi(2,2)/det(M)
               aL_a12(i) = -aM_a12(i)*one_over_detM  !Li(1,2)=-Mi(1,2)/det(M)
               aL_a21(i) = -aM_a21(i)*one_over_detM  !Li(2,1)=-Mi(2,1)/det(M)
c	         if_cor(i)=1
            else    !No correction
               aL_a11(i) = 1.
               aL_a12(i) = 0.
               aL_a21(i) = 0.
               aL_a22(i) = 1.
c	         if_cor(i)=0
             endif
         else !No correction
              aL_a11(i) = 1.
              aL_a12(i) = 0.
              aL_a21(i) = 0.
              aL_a22(i) = 1.
c	        if_cor(i)=0
         endif

c      !- Diagnostic Info -
c      if(i.eq.4793)then
cc        print*
cc        print*,'ac_KGC, itime, rank_id ',itime, rank_id
cc        print*,'ipcount, i ',ipcount, i
cc        print*,'xp, zp ',xp(i),zp(i)
cc        print*,'aM_a '
cc        print*,aM_a11(i), aM_a12(i)
cc        print*,aM_a21(i), aM_a22(i)
c         detMi = detM
cc        print*,'detM ',detM
cc        print*,aL_a11(i), aL_a12(i)
cc        print*,aL_a21(i), aL_a22(i)
cc        print*
cc        if(itime.eq.1)stop
c      endif

      enddo
      
      call SendRecv_KGC_Matrices_toWest
      if(i_call_UpDown    .eq.1) call SendRecv_KGC_Matrices_toBelow
c     if(i_call_NorthSouth.eq.1) call SendRecv_KGC_Matrices_toSouth  !3-D only

c      !- Diagnostic Info -
c      i = 4793
c      if(i.eq.-4793)then
c        print*
c        print*,'ac_KGC, itime, rank_id ',itime, rank_id
c        print*,'ipcount, i ',ipcount, i
c        print*,'xp, zp ',xp(i),zp(i)
c        print*,'aM_a '
c        print*,aM_a11(i), aM_a12(i)
c        print*,aM_a21(i), aM_a22(i)
c        print*,'detM ',detMi
c        print*,aL_a11(i), aL_a12(i)
c        print*,aL_a21(i), aL_a22(i)
c        print*
c        if(itime.eq.1)stop
c      endif

      call ac_main


      return
      end
       
       
