c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine periodicityCorrection(i,j,drx,drz,lx2,lz2,
     &                                 id_call)
c
      include 'common.2D'

      double precision dxp_dble1, dxp_dble2
      double precision dzp_dble1, dzp_dble2

      
           !-- Periodicity Correction --
           !- X-Direction -
           if(lx2.gt.ncx_local)then
              if(drx.gt.four_h)then
                dxp_dble1 = xmax_container_double-dble(xp(i))
                dxp_dble2 = dble(xp(j))-xmin_container_double
                drx = -real(dxp_dble1+dxp_dble2)
              end if
           elseif(lx2.lt.3)then
              if(-drx.gt.four_h)then
                dxp_dble1 = dble(xp(i))-xmin_container_double
                dxp_dble2 = xmax_container_double-dble(xp(j))
                drx =  real(dxp_dble1+dxp_dble2)
              end if
           end if

           !- Z-Direction -
           if(lz2.gt.ncz_local)then
              if(drz.gt.four_h)then
                dzp_dble1 = zmax_container_double-dble(zp(i))
                dzp_dble2 = dble(zp(j))-zmin_container_double
                drz = -real(dzp_dble1+dzp_dble2)
              end if
           elseif(lz2.lt.3)then
              if(-drz.gt.four_h)then
                dzp_dble1 = dble(zp(i))-zmin_container_double
                dzp_dble2 = zmax_container_double-dble(zp(j))
                drz =  real(dzp_dble1+dzp_dble2)
              end if
           end if

      return
      end