c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine update_vorticitySummations_fromWest

      include 'common.2D'
             
      !-- Using Derived DataTypes: ivort_DataType  --
      real curl_data_going_back_East(nGuestmax,2)
      real curl_data_back_from_West(nGuestmax,2)

      itime_check = 10e8   !0   !10e8

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*,'In update_vorticitySummations'
!           print*,'Cartesian Topology'
!         end if
!         call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         do i=0,n_procs-1
!           if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, east, west ',rank_id, east, west 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       
!         !-- Zero non-communicating processes --
!       if(rank_idx.eq.0
!      &   .and.(.NOT.iCartTop_periodicity(1)))then
!         nb_going_West = 0
!         np_going_West = 0
!         if(n_procs_x.eq.1)then
!           nb_going_East = 0
!           np_going_East = 0
!         end if
!       else if(rank_idx.eq.n_procs_x-1
!      &   .and.(.NOT.iCartTop_periodicity(1)))then
!         nb_going_East = 0
!         np_going_East = 0
!         if(n_procs_x.eq.1)then
!           nb_going_West = 0
!           np_going_West = 0
!         end if
!       end if
! 
!         if(rank_id.eq.0)then
!           print*,'In update_accnSummations'
!           print*
!           print*,'rank_id        ',rank_id
!           print*,'nb_local       ',nb_local
!           print*,'np_local       ',np_local
!           print*,'nb_from_East   ',nb_from_East
!           print*,'np_from_East   ',np_from_East
!           print*,'nb_from_West   ',nb_from_West
!           print*,'np_from_West   ',np_from_West
!           print*,'nb_image_local ',nb_image_local
!           print*,'np_image_local ',np_image_local        
!           print*,'nb_going_East   ',nb_going_East
!           print*,'np_going_East   ',np_going_East
!           print*,'nb_going_West   ',nb_going_West
!           print*,'np_going_West   ',np_going_West
!           print*,'east, west      ',east, west 
!         end if
!       end if   !End of:  if(itime.ge.itime_check)then

      !-- Error Catching --
      if(np_from_East.gt.nGuestmax)then
        print*
        print*,'In update_vorticitySummations.f '
        print*,'np_from_East.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_East ',np_from_East
        stop
      end if
      if(np_from_West.gt.nGuestmax)then
        print*
        print*,'In update_vorticitySummations.f '
        print*,'np_from_West.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_West ',np_from_West
        stop
      end if
                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---
      !-- Pack Particle data to be sent back East--
c      if(itime.ge.itime_check)then
c        if(rank_id.eq.0)then
c          print*
c          print*,'Particles Vorticity being sent back East'
c          print*,'rank_id ',rank_id
c          print*,'np_from_East ',np_from_East
c          print*,
c     &  'ii, i_image, xp(i_image), yp(i_image),zp(i_image)'
c        end if
c      end if
      do ii = 1,np_from_East
        !i_image = np_local + np_from_West + ii    !CORRECT THIS FOR DISORDERED PARTICLES!!!!
        !i_image = kk_highest + np_from_West + ii
        i_image = kk_highest + ii
c       curl_data_going_back_East(ii, )    = curl3x_a(i_image)            
        curl_data_going_back_East(ii,1)    = curl3y_a(i_image)            
c       curl_data_going_back_East(ii, )    = curl3z_a(i_image)            
c       curl_data_going_back_East(ii, )    = curl3x_b(i_image)            
        curl_data_going_back_East(ii,2)    = curl3y_b(i_image)            
c       curl_data_going_back_East(ii, )    = curl3z_b(i_image)            
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          print*,
c     &    ii, i_image, xp(i_image), 
c     &    curl3y_a(i_image), curl_data_going_back_East(ii,1)
c        end if         
      end do           

      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !--- SendRecv acceleration summation information back to original processors ---
       
c      !Send data back East
      !---Combined SendRecv to East Neighbour ---
      call MPI_SENDRECV(
     &   curl_data_going_back_East, 1  , ivort_DataType , east, 101,
     &   curl_data_back_from_West , 1  , ivort_DataType , west, 101,
     &   grid_comm, status, ierr)
     
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      
      !-- Unpack Data & Update summations on original processors
      
      !-- UnPack Particle data originally sent West --
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*,'Unpacking data originally sent West'
c        print*,'np_going_West ',np_going_West
c        !print*,'Checking xy-positions'
c        !print*,'ii, i, xp_check, yp_check, xp(i), yp(i)'
c        print*,'ii, i, xp_check, zp_check, xp(i), zp(i),
c     &curl3x_a(i),curl_data_back_from_West(ii)'
c      end if
      nbfm_start    = nbf_in_lx_2 + 1
      nbfreem_start = nbfm_in_lx_2 + 1
      nFP_start     = nb_going_West + 1
      do ii=1,np_going_West     !do ii=1,np_in_lx_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_West_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_West_2(ii-nbf0_in_lx_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_West_3(ii-(nbf0_in_lx_2+nbfm0_in_lx_2))
        !if(ii.le.nb_going_West)then        
        !  i = iBP_going_West(ii)
        else
          i = iFP_going_West(ii-nb_going_West)
        end if 
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          write(*,495),ii,i,xp(i),zp(i),curl3y_a(i),
c     &     curl_data_back_from_West(ii,1)
c        end if        
c       curl3x_a(i)  = curl3x_a(i) + curl_data_back_from_West(ii, )
        curl3y_a(i)  = curl3y_a(i) + curl_data_back_from_West(ii,1)
c       curl3z_a(i)  = curl3z_a(i) + curl_data_back_from_West(ii, )
c       curl3x_b(i)  = curl3x_b(i) + curl_data_back_from_West(ii, )
        curl3y_b(i)  = curl3y_b(i) + curl_data_back_from_West(ii,2)
c       curl3z_b(i)  = curl3z_b(i) + curl_data_back_from_West(ii, )
      end do


495   format(2(i5,'  '),4(e12.6,'  '))      
      
      !stop
        
      end subroutine
